Issue 103936 - Grammar checker thread loops at 100% CPU when anchored-as-character objects in document
Summary: Grammar checker thread loops at 100% CPU when anchored-as-character objects i...
Status: CLOSED FIXED
Alias: None
Product: lingucomponent
Classification: Code
Component: other (show other issues)
Version: OOO310m11
Hardware: All All
: P3 Trivial (vote)
Target Milestone: OOo 3.1.1
Assignee: stefan.baltzer
QA Contact: issues@lingucomponent
URL:
Keywords:
Depends on:
Blocks: 101565
  Show dependency tree
 
Reported: 2009-07-31 14:31 UTC by stefan.baltzer
Modified: 2010-01-12 12:48 UTC (History)
1 user (show)

See Also:
Issue Type: DEFECT
Latest Confirmation in: ---
Developer Difficulty: ---


Attachments
Bugdoc with graphic anchored "as character" (301.70 KB, application/vnd.oasis.opendocument.text)
2009-07-31 14:37 UTC, stefan.baltzer
no flags Details

Note You need to log in before you can comment on or make changes to this issue.
Description stefan.baltzer 2009-07-31 14:31:56 UTC
Scenario: Have the latest German Grammar checker (Duden Korrektor 6, wichis not
free!) installed.
 - Load bugdoc
 - Ensure that  automatic Spell- and Grammar check is enabled
   => As expected, the first three grammar errors get marked in blue.
But...
-> The last three grammar errors get not marked
-> The CPU load goes up to 100%
First evaluation by TL tells that
 - The grammar checker has a thread for itself - that is why office (and
spellcheck) still work. 
 - The grammar checker loops in the paragraph with the anchored-as-character
graphic.
 - Therefore there is no further grammar check below or in next documents. To
the user, it looks like "no errors in the document"

When closing the office, the grammar check thread gets also terminated.
This 100% CPU load easily goes undetected by a single user who has no other
processes than the office running. This massively hinders work in multi-user
environments.
Comment 1 stefan.baltzer 2009-07-31 14:37:33 UTC
Created attachment 63892 [details]
Bugdoc with graphic anchored "as character"
Comment 2 thomas.lange 2009-07-31 15:06:48 UTC
Note: The problem with the specific grammar checker version is that with some
characters in the string the a sentence end is not returned and this results in
endlessly checking the same sentence over and over.

Work-around: Force sentence advancement in the gciterator if the grammar checker
did not advance. Work-around will work for all grammar checkers with similar
problems.
Comment 3 thomas.lange 2009-07-31 15:07:05 UTC
.
Comment 4 thomas.lange 2009-08-03 08:12:32 UTC
Fixed in CWS gciteratorfix.
Comment 5 thomas.lange 2009-08-04 08:33:45 UTC
.
Comment 6 thomas.lange 2009-08-04 12:29:27 UTC
Just for the notes: with current DKO 6 (still unreleased!) loops also occurred
when text fields were present in the document.
Comment 7 stefan.baltzer 2009-08-04 16:56:43 UTC
Verified in CWS gciteratorfix.
Comment 8 stefan.baltzer 2010-01-12 12:48:47 UTC
OK in OOo 3.1.1. and OK in OOO320_m9. Closed.